ImmutableSetMultimap
Date: 2016-05-24

com.google.common.collect

## Class ImmutableSetMultimap<K,V>

- java.lang.Object
- - com.google.common.collect.ImmutableMultimap<K,V>
  - - com.google.common.collect.ImmutableSetMultimap<K,V>

- All Implemented Interfaces:
    Multimap<K,V>, SetMultimap<K,V>, java.io.Serializable

      @GwtCompatible(serializable=true,
                     emulated=true)
      public class ImmutableSetMultimap<K,V>
      extends ImmutableMultimap<K,V>
      implements SetMultimap<K,V>

  A `SetMultimap` whose contents will never change, with many other important properties detailed at `ImmutableCollection`.

  See the Guava User Guide article on immutable collections.

  Since:
    2.0
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `ImmutableSetMultimap.Builder<K,V>` A builder for creating immutable `SetMultimap` instances, especially `public static final` multimaps ("constant multimaps").

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <K,V> ImmutableSetMultimap.Builder<K,V>` | `builder()` Returns a new `ImmutableSetMultimap.Builder`.
    `boolean` | `containsEntry(java.lang.Object key, java.lang.Object value)` Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
    `static <K,V> ImmutableSetMultimap<K,V>` | `copyOf(java.lang.Iterable<? extends java.util.Map.Entry<? extends K,? extends V>> entries)` Returns an immutable multimap containing the specified entries.
    `static <K,V> ImmutableSetMultimap<K,V>` | `copyOf(Multimap<? extends K,? extends V> multimap)` Returns an immutable set multimap containing the same mappings as `multimap`.
    `ImmutableSet<java.util.Map.Entry<K,V>>` | `entries()` Returns an immutable collection of all key-value pairs in the multimap.
    `boolean` | `equals(java.lang.Object object)` Compares the specified object with this multimap for equality.
    `ImmutableSet<V>` | `get(K key)` Returns an immutable set of the values for the given key.
    `int` | `hashCode()` Returns the hash code for this multimap.
    `ImmutableSetMultimap<V,K>` | `inverse()` Returns an immutable multimap which is the inverse of this one.
    `boolean` | `isEmpty()` Returns `true` if this multimap contains no key-value pairs.
    `static <K,V> ImmutableSetMultimap<K,V>` | `of()` Returns the empty multimap.
    `static <K,V> ImmutableSetMultimap<K,V>` | `of(K k1, V v1)` Returns an immutable multimap containing a single entry.
    `static <K,V> ImmutableSetMultimap<K,V>` | `of(K k1, V v1, K k2, V v2)` Returns an immutable multimap containing the given entries, in order.
    `static <K,V> ImmutableSetMultimap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3)` Returns an immutable multimap containing the given entries, in order.
    `static <K,V> ImmutableSetMultimap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4)` Returns an immutable multimap containing the given entries, in order.
    `static <K,V> ImmutableSetMultimap<K,V>` | `of(K k1, V v1, K k2, V v2, K k3, V v3, K k4, V v4, K k5, V v5)` Returns an immutable multimap containing the given entries, in order.
    `ImmutableSet<V>` | `removeAll(java.lang.Object key)` Deprecated. Unsupported operation.
    `ImmutableSet<V>` | `replaceValues(K key, java.lang.Iterable<? extends V> values)` Deprecated. Unsupported operation.
    `java.lang.String` | `toString()` Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.

    - ### Methods inherited from class com.google.common.collect.ImmutableMultimap

      `asMap, clear, containsKey, containsValue, keys, keySet, put, putAll, putAll, remove, size, values`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.common.collect.SetMultimap

      `asMap, equals`

    - ### Methods inherited from interface com.google.common.collect.Multimap

      `clear, containsEntry, containsKey, containsValue, hashCode, isEmpty, keys, keySet, put, putAll, putAll, remove, size, values`

- - ### Method Detail

    - #### of

          public static <K,V> ImmutableSetMultimap<K,V> of()

      Returns the empty multimap.

    - #### of

          public static <K,V> ImmutableSetMultimap<K,V> of(K k1,
                                           V v1)

      Returns an immutable multimap containing a single entry.

    - #### of

          public static <K,V> ImmutableSetMultimap<K,V> of(K k1,
                                           V v1,
                                           K k2,
                                           V v2)

      Returns an immutable multimap containing the given entries, in order. Repeated occurrences of an entry (according to `Object.equals(java.lang.Object)`) after the first are ignored.

    - #### of

          public static <K,V> ImmutableSetMultimap<K,V> of(K k1,
                                           V v1,
                                           K k2,
                                           V v2,
                                           K k3,
                                           V v3)

      Returns an immutable multimap containing the given entries, in order. Repeated occurrences of an entry (according to `Object.equals(java.lang.Object)`) after the first are ignored.

    - #### of

          public static <K,V> ImmutableSetMultimap<K,V> of(K k1,
                                           V v1,
                                           K k2,
                                           V v2,
                                           K k3,
                                           V v3,
                                           K k4,
                                           V v4)

      Returns an immutable multimap containing the given entries, in order. Repeated occurrences of an entry (according to `Object.equals(java.lang.Object)`) after the first are ignored.

    - #### of

          public static <K,V> ImmutableSetMultimap<K,V> of(K k1,
                                           V v1,
                                           K k2,
                                           V v2,
                                           K k3,
                                           V v3,
                                           K k4,
                                           V v4,
                                           K k5,
                                           V v5)

      Returns an immutable multimap containing the given entries, in order. Repeated occurrences of an entry (according to `Object.equals(java.lang.Object)`) after the first are ignored.

    - #### builder

          public static <K,V> ImmutableSetMultimap.Builder<K,V> builder()

      Returns a new `ImmutableSetMultimap.Builder`.

    - #### copyOf

          public static <K,V> ImmutableSetMultimap<K,V> copyOf(Multimap<? extends K,? extends V> multimap)

      Returns an immutable set multimap containing the same mappings as `multimap`. The generated multimap's key and value orderings correspond to the iteration ordering of the `multimap.asMap()` view. Repeated occurrences of an entry in the multimap after the first are ignored.

      Despite the method name, this method attempts to avoid actually copying the data when it is safe to do so. The exact circumstances under which a copy will or will not be performed are undocumented and subject to change.

      Throws:
        `java.lang.NullPointerException` - if any key or value in `multimap` is null

    - #### copyOf

          @Beta
          public static <K,V> ImmutableSetMultimap<K,V> copyOf(java.lang.Iterable<? extends java.util.Map.Entry<? extends K,? extends V>> entries)

      Returns an immutable multimap containing the specified entries. The returned multimap iterates over keys in the order they were first encountered in the input, and the values for each key are iterated in the order they were encountered. If two values for the same key are equal, the first value encountered is used.
      Throws:
        `java.lang.NullPointerException` - if any key, value, or entry is null
      Since:
        19.0

    - #### get

          public ImmutableSet<V> get(@Nullable
                            K key)

      Returns an immutable set of the values for the given key. If no mappings in the multimap have the provided key, an empty immutable set is returned. The values are in the same order as the parameters used to build this multimap.
      Specified by:
        `get` in interface `Multimap<K,V>`
      Specified by:
        `get` in interface `SetMultimap<K,V>`
      Specified by:
        `get` in class `ImmutableMultimap<K,V>`

    - #### inverse

          public ImmutableSetMultimap<V,K> inverse()

      Returns an immutable multimap which is the inverse of this one. For every key-value mapping in the original, the result will have a mapping with key and value reversed.

      Because an inverse of a set multimap cannot contain multiple pairs with the same key and value, this method returns an `ImmutableSetMultimap` rather than the `ImmutableMultimap` specified in the `ImmutableMultimap` class.

      Specified by:
        `inverse` in class `ImmutableMultimap<K,V>`
      Since:
        11.0

    - #### removeAll

          @Deprecated
          public ImmutableSet<V> removeAll(java.lang.Object key)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `removeAll` in interface `Multimap<K,V>`
      Specified by:
        `removeAll` in interface `SetMultimap<K,V>`
      Overrides:
        `removeAll` in class `ImmutableMultimap<K,V>`
      Returns:
        the values that were removed (possibly empty). The returned collection may be modifiable, but updating it will have no effect on the multimap.
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### replaceValues

          @Deprecated
          public ImmutableSet<V> replaceValues(K key,
                                                 java.lang.Iterable<? extends V> values)

      Deprecated. Unsupported operation.
      Guaranteed to throw an exception and leave the multimap unmodified.
      Specified by:
        `replaceValues` in interface `Multimap<K,V>`
      Specified by:
        `replaceValues` in interface `SetMultimap<K,V>`
      Overrides:
        `replaceValues` in class `ImmutableMultimap<K,V>`
      Returns:
        the collection of replaced values, or an empty collection if no values were previously associated with the key. The collection may be modifiable, but updating it will have no effect on the multimap.
      Throws:
        `java.lang.UnsupportedOperationException` - always

    - #### entries

          public ImmutableSet<java.util.Map.Entry<K,V>> entries()

      Returns an immutable collection of all key-value pairs in the multimap. Its iterator traverses the values for the first key, the values for the second key, and so on.
      Specified by:
        `entries` in interface `Multimap<K,V>`
      Specified by:
        `entries` in interface `SetMultimap<K,V>`
      Overrides:
        `entries` in class `ImmutableMultimap<K,V>`

    - #### isEmpty

          public boolean isEmpty()

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains no key-value pairs. Equivalent to `size() == 0`, but can in some cases be more efficient.
      Specified by:
        `isEmpty` in interface `Multimap<K,V>`

    - #### containsEntry

          public boolean containsEntry(@Nullable
                              java.lang.Object key,
                              @Nullable
                              java.lang.Object value)

      Description copied from interface: `Multimap`
      Returns `true` if this multimap contains at least one key-value pair with the key `key` and the value `value`.
      Specified by:
        `containsEntry` in interface `Multimap<K,V>`

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object object)

      Description copied from interface: `Multimap`
      Compares the specified object with this multimap for equality. Two multimaps are equal when their map views, as returned by `Multimap.asMap()`, are also equal.

      In general, two multimaps with identical key-value mappings may or may not be equal, depending on the implementation. For example, two `SetMultimap` instances with the same key-value mappings are equal, but equality of two `ListMultimap` instances depends on the ordering of the values for each key.

      A non-empty `SetMultimap` cannot be equal to a non-empty `ListMultimap`, since their `Multimap.asMap()` views contain unequal collections as values. However, any two empty multimaps are equal, because they both have empty `Multimap.asMap()` views.

      Specified by:
        `equals` in interface `Multimap<K,V>`
      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Returns the hash code for this multimap.

      The hash code of a multimap is defined as the hash code of the map view, as returned by `Multimap.asMap()`.

      Specified by:
        `hashCode` in interface `Multimap<K,V>`
      Overrides:
        `hashCode` in class `java.lang.Object`
      See Also:
        `Map.hashCode()`

    - #### toString

          public java.lang.String toString()

      Returns a string representation of the multimap, generated by calling `toString` on the map returned by `Multimap.asMap()`.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        a string representation of the multimap